'use strict';

exports.__esModule = true;
exports.FormItemModel = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _v = require('uuid/v1');

var _v2 = _interopRequireDefault(_v);

var _lodash = require('lodash');

var _FieldsModel = require('./FieldsModel');

var _FieldsModel2 = _interopRequireDefault(_FieldsModel);

var _FormsModel = require('./FormsModel');

var _FormsModel2 = _interopRequireDefault(_FormsModel);

var _FormItemModelPublic = require('./public/FormItemModelPublic');

var _FormItemModelPublic2 = _interopRequireDefault(_FormItemModelPublic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItemModel = function () {
  function FormItemModel(name, validator) {
    var _this = this;

    var excluded = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    (0, _classCallCheck3.default)(this, FormItemModel);

    this.getPublic = function () {
      return _this.__getPublic__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.validate = function () {
      return _this.__validate__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reload = function () {
      return _this.__reload__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.addErrors = function () {
      return _this.__addErrors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isValid = function () {
      return _this.__isValid__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isTouched = function () {
      return _this.__isTouched__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.init = function () {
      return _this.__init__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reset = function () {
      return _this.__reset__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeDirty = function () {
      return _this.__makeDirty__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeSubmitted = function () {
      return _this.__makeSubmitted__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.data = function () {
      return _this.__data__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.values = function () {
      return _this.__values__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.getErrors = function () {
      return _this.__getErrors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.id = (0, _v2.default)();
    this.name = name;
    this.excluded = excluded;
    this.validator = validator || function () {
      return [];
    };
    this.fields = new _FieldsModel2.default();
    this.forms = new _FormsModel2.default();
    this.public = new _FormItemModelPublic2.default(this);
  }

  FormItemModel.prototype.__getPublic__REACT_HOT_LOADER__ = function __getPublic__REACT_HOT_LOADER__() {
    return this.public;
  };

  FormItemModel.prototype.__validate__REACT_HOT_LOADER__ = function __validate__REACT_HOT_LOADER__() {
    this.fields.validate();
    this.forms.validate();
  };

  FormItemModel.prototype.__reload__REACT_HOT_LOADER__ = function __reload__REACT_HOT_LOADER__() {
    this.fields.reload();
    this.forms.reload();
  };

  FormItemModel.prototype.__addErrors__REACT_HOT_LOADER__ = function __addErrors__REACT_HOT_LOADER__() {
    var parentErrors = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var customizer = function customizer(objValue, srcValue) {
      if (Array.isArray(objValue)) {
        return objValue.concat(srcValue);
      }
    };
    var errors = this.validator(this, this.fields, this.fields.data());
    var mergedErrors = (0, _lodash.mergeWith)((0, _extends3.default)({}, parentErrors), errors, customizer);
    this.fields.addErrors(mergedErrors);
    this.forms.addErrors(mergedErrors);
  };

  FormItemModel.prototype.__isValid__REACT_HOT_LOADER__ = function __isValid__REACT_HOT_LOADER__() {
    return this.fields.isValid() && this.forms.isValid();
  };

  FormItemModel.prototype.__isTouched__REACT_HOT_LOADER__ = function __isTouched__REACT_HOT_LOADER__() {
    return this.fields.isTouched() || this.forms.isTouched();
  };

  FormItemModel.prototype.__init__REACT_HOT_LOADER__ = function __init__REACT_HOT_LOADER__() {
    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    this.fields.init(data);
    this.forms.init(data);
  };

  FormItemModel.prototype.__reset__REACT_HOT_LOADER__ = function __reset__REACT_HOT_LOADER__() {
    this.fields.reset();
    this.forms.reset();
  };

  FormItemModel.prototype.__makeDirty__REACT_HOT_LOADER__ = function __makeDirty__REACT_HOT_LOADER__() {
    this.fields.makeDirty();
    this.forms.makeDirty();
  };

  FormItemModel.prototype.__makeSubmitted__REACT_HOT_LOADER__ = function __makeSubmitted__REACT_HOT_LOADER__() {
    this.fields.makeSubmitted();
    this.forms.makeSubmitted();
  };

  FormItemModel.prototype.__data__REACT_HOT_LOADER__ = function __data__REACT_HOT_LOADER__() {
    return (0, _extends3.default)({}, this.fields.data(), this.forms.data());
  };

  FormItemModel.prototype.__values__REACT_HOT_LOADER__ = function __values__REACT_HOT_LOADER__() {
    return (0, _extends3.default)({}, this.fields.values(), this.forms.values());
  };

  FormItemModel.prototype.__getErrors__REACT_HOT_LOADER__ = function __getErrors__REACT_HOT_LOADER__() {
    return {
      fields: this.fields.errors(),
      forms: this.forms.errors()
    };
  };

  return FormItemModel;
}();

exports.FormItemModel = FormItemModel;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FormItemModel, 'FormItemModel', 'E:/Projects/React/git/vb-react-form/src/FormsV1/Form/FormItemModel.js');
}();

;