'use strict';

exports.__esModule = true;
exports.FieldErrors = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormModel = require('../Form/FormModel');

var _FormItemModel = require('../Form/FormItemModel');

var _FieldErrorsComponent = require('./FieldErrorsComponent');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FieldErrors = function (_PureComponent) {
  (0, _inherits3.default)(FieldErrors, _PureComponent);

  function FieldErrors(props, context) {
    (0, _classCallCheck3.default)(this, FieldErrors);

    var _this = (0, _possibleConstructorReturn3.default)(this, _PureComponent.call(this, props, context));

    _this.formModel = context.formModel;
    _this.formItemModel = context.formItemModel;
    return _this;
  }

  FieldErrors.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.subscriberId = this.formModel.addSubscriber(function () {
      _this2.forceUpdate();
    });
  };

  FieldErrors.prototype.componentWillUnmount = function componentWillUnmount() {
    this.formModel.removeSubscriber(this.subscriberId);
  };

  FieldErrors.prototype.render = function render() {
    if (this.formModel.initialized) {
      var _props = this.props,
          name = _props.name,
          component = _props.component,
          other = (0, _objectWithoutProperties3.default)(_props, ['name', 'component']);

      var field = null;
      if (this.formItemModel) {
        field = this.formItemModel.fields.field(name);
      } else {
        field = this.formModel.fields.field(name);
      }
      return _react2.default.createElement(component, (0, _extends3.default)({
        form: this.formModel.getPublic(),
        formItem: this.formItemModel && this.formItemModel.getPublic(),
        field: field && field.getPublic()
      }, other));
    }
    return null;
  };

  return FieldErrors;
}(_react.PureComponent);

FieldErrors.propTypes = {
  name: _propTypes2.default.string,
  component: _propTypes2.default.func
};
FieldErrors.defaultProps = {
  name: '',
  component: _FieldErrorsComponent.FieldErrorsComponent
};
FieldErrors.contextTypes = {
  formModel: _propTypes2.default.instanceOf(_FormModel.FormModel).isRequired,
  formItemModel: _propTypes2.default.instanceOf(_FormItemModel.FormItemModel)
};
exports.FieldErrors = FieldErrors;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FieldErrors, 'FieldErrors', 'E:/Projects/React/git/vb-react-form/src/FormsV1/FormField/FieldErrors.js');
}();

;